import { Any } from 'ts-toolbelt';

type AnyFn = (...args: any[]) => any;
type InstrumentFunction = <X extends AnyFn>(name: string, fn: X) => X;

type Submodule<InitArgs = {}, Config = {}, Services = {}> = Any.Compute<{
    createConfig?: (createConfigParams: {
        initArgs: InitArgs;
    }) => Config | Promise<Config>;
    createServices?: (createServiceParams: {
        initArgs: InitArgs;
        config: Config;
    }) => Services | Promise<Services>;
}, "flat">;
type Executable<InitArgs, Config, Services, Input, Output> = (executableParam: {
    config: Config;
    services: Services;
    initArgs: InitArgs;
}, input: Input) => Output | Promise<Output>;
type ExecutableOptions<InitArgs> = {
    eager?: boolean;
    initArgs?: () => (InitArgs | Promise<InitArgs>);
    instrument?: InstrumentFunction;
};
type Executor<InitArgs, Config, Services> = {
    execute: <Input extends any, Output>(executable: Executable<InitArgs, Config, Services, Input, Output>, input?: Input) => Promise<Output>;
    prepare: <Input extends any, Output>(executable: Executable<InitArgs, Config, Services, Input, Output>) => (input: Input) => Promise<Output>;
    config(): Promise<Config>;
    services(): Promise<Services>;
};
declare const prepareExecutable: <InitArgs = {}, Config = {}, Services = {}>(submoduleDef: {
    createConfig?: ((createConfigParams: {
        initArgs: InitArgs;
    }) => Config | Promise<Config>) | undefined;
    createServices?: ((createServiceParams: {
        initArgs: InitArgs;
        config: Config;
    }) => Services | Promise<Services>) | undefined;
}, options?: ExecutableOptions<InitArgs> | undefined) => Executor<InitArgs, Config, Services>;

export { ExecutableOptions, Executor, Submodule, prepareExecutable };
